//****************************************************************************
// et un petit exemple pour comprendre comment tout ce petit monde fonctionne
// ===========================================================================
// Les compteurs (s)
// ***************************************************************************
#include <Autom.h>
/*
* Certe une grosse bibliotheque pour 
Seulement un compteur
*/

// un objet appli dans lequel on va installer le système de graphes, tempos ....
project appli=project();



// déclaration des tempos
compt C1=compt(6,"Cmpt1"); // un compteur avec une preselection de 20 nommé cmpt1

// Les entrés

#define pinBplus 13 // le bouton plus
boolean boutonPlus = false;

#define pinBmoins 10 // le bouton moins
boolean boutonMoins = false;

#define pinBpre 12 // le bouton preselection
boolean boutonPre = false;

#define pinBrst 11 // le bouton reset (mise à zerro)
boolean boutonRst = false;

#define pinBpre5 A5 // le bouton presel=5
boolean boutonPre5 = false;

#define pinBpre10 A4 // le bouton presel=10
boolean boutonPre10 = false;

#define pinBcycle A3 // le bouton selection cycle/compt
boolean boutonCycle = false;
// les sorties

#define pinledInf A0 // le voyant compteur inférieur à  presel
#define pinledEgal A1 // le voyant compteur egale à presel
#define pinledSup A2 // le voyant compteur supérieur à presel, compteur

#define pinb0 2 // la premiere pin pour la sortie binaire

float cyclemoy = 0;

// Les procedures à écrire pour décrire le fonctionnement de l'application 
// ***********************************************************************
// Les phases de fonctionnement du système numérique associé
//************************************************************************

void preliminaire_appli() // calculs preliminaires ex fronts prise de valeurs digitales, analogiques ...
{
	boutonPlus=digitalRead(pinBplus); // prise de l'état du bouton Bplus
	boutonMoins=digitalRead(pinBmoins); // prise de l'état du bouton Bmoins	
	boutonRst=digitalRead(pinBrst); // prise de l'état du bouton Brst
	boutonPre=digitalRead(pinBpre); // prise de l'état du bouton Bpre  
	boutonPre5=digitalRead(pinBpre5); // prise de l'état du bouton Bpre5
	boutonPre10=digitalRead(pinBpre10); // prise de l'état du bouton Bpre10 
	boutonCycle=digitalRead(pinBcycle); // prise de l'état du bouton Cycle/compteur 
}
//********************************************************************************
void calculEvolution_appli() // préparation de l'évolution des graphes en suivant les transitions
{

}
//*******************************************************************************
void posterieur_appli() // typiquement affectation des sorties
{

	// Premièrement Traitement des figeages et forcages;

	// Deuxiemement activer les tempos et compteurs
	if (boutonPlus) {C1.comptUp();}; // compter
	if (boutonMoins) {C1.comptDown();}; // decompter
	if (boutonPre) {C1.preSet();}; // mise à la valeur preset
	if (boutonRst) {C1.reSet();}; // reset (mise à 0)
	if (boutonPre5 & !boutonPre10) {C1.setPresel(5);}  // preselection = 5
	if (boutonPre10 & !boutonPre5) {C1.setPresel(10);} // preselection = 10

	// Troisièmement Traitement des sorties

	// Les bits internes

	// Les sortie tout ou rien externes

	digitalWrite(pinledEgal,C1.isEqual()); // diode =
	digitalWrite(pinledSup,C1.isUpper()); // diode >
	digitalWrite(pinledInf,C1.isLower()); // diode <

	// recalcul du temps de cycle moyen
	cyclemoy=(99*cyclemoy+appli.getCycle())/100;

	// affichage
	word b;
	if (boutonCycle) {b=cyclemoy; } else {b=C1.val();} // on choisi la valeur à afficher
	// affichage de la valeur sur des bits de sortie 
	for (int i=0;i<8;i++) {digitalWrite(pinb0+i,boolean(b&(0x01<<i)));};
}
//********************************************************************
void setup() // initialisation E/S , series ....
{
	pinMode(pinBplus,INPUT_PULLUP);
	pinMode(pinBmoins,INPUT_PULLUP);
	pinMode(pinledEgal,OUTPUT);
	pinMode(pinledInf,OUTPUT);
	pinMode(pinledSup,OUTPUT);
	pinMode(pinBrst,INPUT_PULLUP);
	pinMode(pinBpre,INPUT_PULLUP);
	pinMode(pinBpre5,INPUT_PULLUP);
	pinMode(pinBpre10,INPUT_PULLUP);
	pinMode(pinBcycle,INPUT_PULLUP);

	for (int i=0;i<8;i++) {pinMode(pinb0+i,OUTPUT);};

	// Mise en place du mode de debogage sur la sortie serie Serial
	appli.debugMode(&Serial,9600); // mise en place du mode de debogage

	// on installe les entités dans l'application
	appli.add(&C1);
	
	// on affecte les fonctions
	appli.setPreliminaire(preliminaire_appli);
	appli.setCalculEvolution(calculEvolution_appli);
	appli.setPosterieur(posterieur_appli);
}

//*************************************************
void loop() // Le chef d'orchestre (le vrai !)
{
	// mise à jour obligatoire des variables globales tous les tours de calcul
	initLoop(); 
	// et c'est parti tout est intégré dedans !!
	appli.fonctionnement(); 

}


